`timescale 1ns/10ps
`define CYCLE      10.0  
`define End_CYCLE  1000000

module tb;

    // Register
    reg clk = 0;
    reg rst = 0;
    /*
        Declare your input ports
        Example:
        reg [7:0] input_1,
        reg [7:0] input_2,
        
            .
            .
            .
    */
    /*
        Declare your output ports
        Example:
        wire [7:0] output_1,
        wire [7:0] output_2,
        
            .
            .
            .
    */

    // Test Module
    dut dut_name
    (
        .clk(clk), 
        .rst(rst), 
        /*
        Connect your ports to top module
        Example:
        .your_port_1(input_1),
        .your_port_2(input_2),
        .your_port_3(output_1),
        .your_port_4(output_2),

            .
            .
            .
        */
    );

    // System Clock (Don't modify this)
    always 
    begin 
        #(`CYCLE/2) clk = ~clk; 
    end

    // Initialization
    initial 
    begin
        $display("----------------------");
        $display("-- Simulation Start --");
        $display("----------------------");
        rst = 1'b1; 
        #(`CYCLE * 2);  
        rst = 1'b0;
        //test calculator

        /**************************************/
        /* use # + number to set the time line*/
        /* ex: #10 means 10 time unit         */
        /**************************************/

        /* Example:
            #(`CYCLE) input_1 = 2'b01; input_2 = 2'b11;
            #(`CYCLE*5) input_1 = 2'b11; input_2 = 2'b10;
            #(`CYCLE*2) input_1 = 2'b00; input_2 = 2'b10;

            the example of line 1 => after one cycle, the input_1 = 2'b01, input_2 = 2'b11;
                           line 2 => after 5 more cycles, the input_1 = 2'b11, input_2 = 2'b10;
                           line 3 => after 2 more cycles, the input_1 = 2'b00, input_2 = 2'b10;    
        */
        $finish;
    end

    reg [22:0] cycle=0;
    // Check whether in forever loop
    always @(posedge clk) 
    begin
        cycle = cycle + 1;
        if (cycle > `End_CYCLE) 
        begin
            $display("----------------------------------------");
            $display("-- Max cycle reached, Simulation STOP --");
            $display("----------------------------------------");
            $finish;
        end
    end
        
endmodule